using UnityEditor;
using System.Collections;

public class OMTestSuiteEditorCoroutines
{
    readonly IEnumerator mRoutine;

    public static OMTestSuiteEditorCoroutines StartEditorCoroutine( IEnumerator routine)
    {
        OMTestSuiteEditorCoroutines coroutine = new OMTestSuiteEditorCoroutines(routine);
        coroutine.start();
        return coroutine;
    }

    OMTestSuiteEditorCoroutines(IEnumerator routine)
    {
        mRoutine = routine;
    }

    void start()
    {
        EditorApplication.update += update;
    }

    void update()
    {
        if(!mRoutine.MoveNext())
        {
            StopEditorCoroutine();
        }
    }

    public void StopEditorCoroutine()
    {
        EditorApplication.update -= update;
    }
}
